#!/bin/sh
#$Id: reinitializeDB.sh,v 1.3 2009/05/29 06:54:12 vasus Exp $

. ./setCommonEnv.sh

FORCEFUL_REINIT="false"
CLASS_PATH=$SERVER_HOME/lib/mickey3.jar:$SERVER_HOME/lib/SwisSQLAPI.jar:$SERVER_HOME/lib/AdvMicroFramework.jar:$SERVER_HOME/lib/AdvPersistence.jar:$SERVER_HOME/lib/ojdbc14.jar:$SERVER_HOME/lib/mysql_connector.jar:$SERVER_HOME/bin/run.jar:$SERVER_HOME/lib/jboss-j2ee.jar:$SERVER_HOME/lib/jboss-jca.jar:$SERVER_HOME/lib/jboss-compressed.jar:$SERVER_HOME/lib/concurrent.jar:$SERVER_HOME/lib/jboss-common-jdbc-wrapper.jar:$SERVER_HOME/lib/jboss-transaction.jar:$SERVER_HOME/lib/AdvCoreLogging.jar:$SERVER_HOME/AdvMickeyLiteLogging.jar:$SERVER_HOME/lib/tomcat/commons-logging-api.jar
if [ $# -ne 0 ]; then
	if [ $1 = "-A" ]; then
		rm -rf $SERVER_HOME/logs/* $SERVER_HOME/work
	fi
    if [ $1 = "-f" ]
    then
        FORCEFUL_REINIT="true"
    fi
fi

$JAVA $JAVA_OPTS -cp $SERVER_HOME/bin/run.jar com.adventnet.mfw.util.JdkAndPortCheck
if [ $? -ne 0 ]
then
        exit 1
fi
    
$JAVA -Dserver.home=$SERVER_HOME -Ddb.home=$DB_HOME -cp $CLASS_PATH com.adventnet.mfw.util.ReinitializeDB $FORCEFUL_REINIT

rm -rf $SERVER_HOME/schedule_results
