/* $Id: configuration.js,v 1.48 2009/06/08 14:58:05 vasus Exp $ */
function populateLabelDescr(form)
{
  selectedLabelObj = document.getElementById("LABEL_NAME");
  selectedLabel = selectedLabelObj.options[selectedLabelObj.selectedIndex].value;
  description = document.getElementById("DESCRIPTION");
  if(selectedLabel == 'New Label')
  {
    description.readOnly = false;
    description.value = "";
    document.getElementById("NEW_LABEL").className = "textfield";
    document.getElementById("DESCRIPTION").className = "textfield";
  }
  else
  {
    description.readOnly = true;
    document.getElementById("NEW_LABEL").className = "hide";
	document.getElementById("DESCRIPTION").className = "textdisabled";
    description.value=eval("label." + selectedLabel);
  }
}

function checkNewLabel(form)
{
  var newLabel = form.NEW_LABEL_NAME.value;
  if(!isNotEmpty(newLabel))
  {
    alert("Enter a valid label name");
    return false;
  }
  
  var availableLabels = form.LABEL_NAME.options;
  var len = availableLabels.length;
  for(var i=0;i<len;i++)
  {
    if(availableLabels[i].value == newLabel)
    {
      alert("A label with this name already exists. Enter a different name");
      return false;
    }
  }
  
  return true;
  
}

function showConfigFileDetailsEditMode(status)
{
  var editButtonsObj = MM_findObj('edit_buttons');
  var editLink = MM_findObj('edit_link');
//  var downloadLink = MM_findObj('download_link');
  
  if(status)
  {
    document.ConfigFileDetails_FRM.ANNOTATION.disabled = false;
    editButtonsObj.className='tablerowslight';
    editLink.className='hide';
//    downloadLink.className='hide';
  }
  else
  {
    document.ConfigFileDetails_FRM.ANNOTATION.disabled = true;
    editButtonsObj.className='hide';
    editLink.className='tablerowslight';
//    downloadLink.className='tablerowslight';
  }
}

function showDraftDetailsEditMode(status)
{
    status = (status == true || status == false ) ? status : true;
    var editButtonsObj = MM_findObj('edit_buttons');
    var viewAnnotation = MM_findObj('view_annotation');
    var editAnnotation = MM_findObj('edit_annotation');
    var comboDraftName = MM_findObj('draft_name_combo');
    var textDraftName = MM_findObj('draft_name_text');
    var spacerow = MM_findObj('view_spacerow');

    if(status)
    {
        document.DraftDetailsView_FRM.FILE_CONTENTS.readOnly = false;
        document.DraftDetailsView_FRM.FILE_CONTENTS.className = "textarea_bg";
		document.DraftDetailsView_FRM.FILE_CONTENTS.focus();
        viewAnnotation.className = "hide";
        editAnnotation.className = "";    
        editButtonsObj.className = "tablerowslight";
        textDraftName.className = "";    
        comboDraftName.className = "hide";
	spacerow.className = "hide";

        disableConfigMenu();	
    }    
    else
    {
        document.DraftDetailsView_FRM.FILE_CONTENTS.readOnly = true;
        document.DraftDetailsView_FRM.FILE_CONTENTS.className = "textarea_bg";
        viewAnnotation.className = "";
        editAnnotation.className = "hide";    
        editButtonsObj.className = "hide";
        textDraftName.className = "hide";    
        comboDraftName.className = "";        
	spacerow.className = "";
	
	enableConfigMenu();
    }
    
    
}

function checkDraftType(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    var baseVersionAvailable = document.DraftDetailsView_FRM.BASE_VERSION_AVAILABILITY.value;
    if(baseVersionAvailable == "false")
    {
        alert("Base version not available for this draft");
        return;
    }
    // hostname variable is generated from ViewConfigFileDetails.jsp
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=Host Name : "+hostname+",width=900,closePrevious=false");
}

function checkIfPrevVersionExists(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    if(!menuItemObj.isAtleastOneChecked(srcViewRefId,additionalParams,index))
    {
        return;
    }

    if(!menuItemObj.confirmAction())
    {
        return;
    }
    var tblModel = getTableModel(srcViewRefId);
    var selectedIndices = tblModel.getSelectedRowIndices();

    var versionNo = tblModel.getValueAt(selectedIndices[0],tblModel.getColumnIndex("VERSION_NO"));
    if(versionNo == "1")
    {
        alert("Previous version not available");
        return;
    }
    menuItemObj.invokeActionURL(menuItemObj.getActionURL(srcViewRefId,additionalParams,index));
}

function checkIfVersionIsBaseline(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    if(!menuItemObj.isAtleastOneChecked(srcViewRefId,additionalParams,index))
    {
        return;
    }

    if(!menuItemObj.confirmAction())
    {
        return;
    }

    var tblModel = getTableModel(srcViewRefId);
    var selectedIndices = tblModel.getSelectedRowIndices();

    var labelName = tblModel.getValueAt(selectedIndices[0],tblModel.getColumnIndex("LABEL_NAME"));
    if(labelName != null && labelName == "BASELINE")
    {
        alert("The selected version is the baseline version");
        return;
    }
    menuItemObj.invokeActionURL(menuItemObj.getActionURL(srcViewRefId,additionalParams,index));
}

function validateDraftName(draftNameArray,draftName)
{ 
    var newDraftName = trimAll(draftName);
    var namesLen =draftNameArray.length;
    for(var j=0;j<namesLen;j++)
    {
        if(draftNameArray[j] == newDraftName)
        {
            alert("A Draft with this name already exists. Enter a different name");
            return false;
        }
    }
    return true;
}

function checkIfPrevVersionExists_Popup(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    // versionno and hostname variables are generated from ViewConfigFileDetails.jsp
    if(versionno == "1")
    {
        alert("Previous version not available");
        return;
    }
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=Host Name : "+hostname+",width=900,closePrevious=false");
}


function checkIfVersionIsBaseline_Popup(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    // isbaseline variable generated from ViewConfigFileDetails.jsp
    if(isbaseline)
    {
        alert("This is the baseline version");
        return;
    }
    // hostname variable is generated from ViewConfigFileDetails.jsp
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=Host Name : "+hostname+",width=900,closePrevious=false");
}

function checkIfStartupAvailable_Popup(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    // iscounterpartavailable variable generated from ViewConfigFileDetails.jsp
    if(!iscounterpartavailable)
    {
        alert("No Startup configuration available.");
        return;
    }
    // resourceid and hostname variables are generated from ViewConfigFileDetails.jsp
    additionalParams += "&RESOURCEID="+resourceid;
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=Host Name : "+hostname+",width=900,closePrevious=false");
}

function checkIfRunningAvailable_Popup(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    // iscounterpartavailable variable generated from ViewConfigFileDetails.jsp
    if(!iscounterpartavailable)
    {
        alert("No Running configuration available.");
        return;
    }
    // resourceid and hostname variables are generated from ViewConfigFileDetails.jsp
    additionalParams += "&RESOURCEID="+resourceid;
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=Host Name : "+hostname+",width=900,closePrevious=false");
}

function showDiffWithCurrent(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    // hostname variable is generated from ViewConfigFileDetails.jsp
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=Host Name : "+hostname+",width=900,closePrevious=false");
}

function showVersionInfo(selectobj)
{
    var selectedvalue = selectobj.options[selectobj.selectedIndex].value;
    var reqparams = 'RESOURCEID=' + resourceid + '&VERSION_ID=' + selectedvalue;
    updateViewInCA('NCMConfigFileDetailsView',uniqueid,null,'ConfigDetailsTabContentArea',null,true,null,reqparams,true);
}


function showDraftInfo(selectobj)
{
    var selectedvalue = selectobj.options[selectobj.selectedIndex].value;
    var reqparams = 'RESOURCEID=' + resourceid + '&DRAFT_ID=' + selectedvalue;
    updateViewInCA('NCMDraftDetailsView',uniqueid,null,'ConfigDetailsTabContentArea',null,true,null,reqparams,true);
}

function associateLabelDialog(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=Associate Label,closePrevious=false",null,srcViewRefId);
}

function uploadDraftConfigFile(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=Upload Draft Configuration,closePrevious=false");
}


function uploadConfigFile(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=Upload Configuration,closePrevious=false");
}


function changeResourceInfo(form)
{
    var selectedIndex = form.DEVICE_SELECT.selectedIndex;
    var selectedDevice = null;
    var selectedResourceID = null;
    if( selectedIndex == -1 )
    {
	selectedResourceID = -1;
    }
    else
    {
	selectedResourceID = form.DEVICE_SELECT.options[selectedIndex].value;
	stateData[uniqueid]["SEL_RES"] =  selectedResourceID;
    }

    stateData["NCMDiffWithAnyTabView"]["_D_RP"]= "&RESOURCEID=" +selectedResourceID;
    var dacarray = getDacArray('DiffWithAnyArea');
    var refid = dacarray[dacarray.length - 1];
    var tempuniqueid = getUniqueId(refid);
    stateData[tempuniqueid]["_D_RP"]= "&RESOURCEID=" +selectedResourceID;
    refreshSubView("NCMDiffWithAnyTabView");
}

function selectedFileForDiff()
{
    var selectedTab = stateData["NCMDiffWithAnyTab"]["selectedView"];
    var uniqueid = selectedTab;
    var colName= "VERSION_ID";
    if (selectedTab == 'NCMDevicePropDraft')
    {
	colName = "DRAFT_ID";
    }

    var tblModel = getTableModel(uniqueid);
    if(!tblModel.isAtleastOneChecked("Select atleast one row to show diff."))
    {
	return;
    }

    document.diffwithany.DIFF_ID_1.value = "&" + colName + "=" + tblModel.getValueAt(tblModel.getSelectedRowIndices()[0],
	    tblModel.getColumnIndex(colName));

    var file1 = document.diffwithany.DIFF_ID_1.value;
    var file1Index = file1.indexOf('=');
    var fileType1 = file1.substr(0,file1Index);
    var file1Id = file1.substr(file1Index + 1,file1.length);

    var file2 = document.diffwithany.DIFF_ID_2.value;
    var file2Index = file2.indexOf('=');
    var fileType2 = file2.substr(0,file2Index);
    var file2Id = file2.substr(file2Index + 1,file2.length);

    if(fileType1 == '&VERSION_ID' &&  fileType2 == 'VERSION_ID')
    {
	if(file1Id == file2Id)
	{
	    alert('Both the files selected for viewing diff are the same. Choose a different file');
	    return;
	}
    }
    // both files are drafts
    else if(fileType1 == '&DRAFT_ID' &&  fileType2 == 'DRAFT_ID')
    {
	if(file1Id == file2Id)
	{
	    alert('Both the files selected for viewing diff are the same. Choose a different file');
	    return;
	}
    }

    //document.diffwithany.submit();
    AjaxAPI.submit(document.diffwithany);
}

function setBeforeSearch(value)
{
    if(value.length == 1)
    {
	stateData["NCMDiffWithAnyTabView"]["_D_RP"] = "&RESOURCEID=-1";
	refreshSubView("NCMDiffWithAnyTabView");
    }
}


function showConfigFileDetails(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    var url = menuItemObj.getActionURL(srcViewRefId,additionalParams,index);
    
    startupregex = /.*Startup.*/
    runningregex = /.*Running.*/
    if(url.match(startupregex))
    {
    	url += "&SELECTEDVIEW=NCMStartupConfigView";
    }
    else if(url.match(runningregex))
    {
    	url += "&SELECTEDVIEW=NCMRunningConfigView";
    }
    else
    {
        url += "&SELECTEDVIEW=NCMDraftView";
    }
    
    showURLInDialog(url,"title=Device Configuration,width=710,height=600,scrollbars=no,draggable=no");
}

function diffWithAnyPopup(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=Configuration Difference with any devices,width=900,closePrevious=false");
}


function enableConfigMenu()
{
    enableConfigActionMenu();
    enableConfigDiffMenu();
}


function disableConfigMenu()
{
    disableConfigActionMenu();
    disableConfigDiffMenu();
}

function enableConfigDiffMenu()
{
    var diffobj = document.getElementById("showdiff_commondropdown_BTN");
    diffobj.className = "showdiffmenu";
    diffobj.disabled = false;
}

function disableConfigDiffMenu()
{
    var diffobj = document.getElementById("showdiff_commondropdown_BTN");
    diffobj.className = "showdiffmenudisabled";
    diffobj.disabled = true;
}

function enableConfigActionMenu()
{
    var actionobj = document.getElementById("actions_commondropdown_BTN");
    actionobj.className = "showactionmenu";
    actionobj.disabled = false;
}

function disableConfigActionMenu()
{
    var actionobj = document.getElementById("actions_commondropdown_BTN");
    actionobj.className = "showactionmenudisabled";
    actionobj.disabled = true;
}

function invokeAuthorizeComments(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    
    if(!menuItemObj.isAtleastOneChecked(srcViewRefId,additionalParams,index))
    {
        return;
    }else{
	showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=Authorize Changes,closePrevious=false",null,srcViewRefId);
      }
}

function invokeUnAuthorizeComments(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);

    if(!menuItemObj.isAtleastOneChecked(srcViewRefId,additionalParams,index))
    {
        return;
    }else{    
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=UnAuthorize Changes,closePrevious=false",null,srcViewRefId);
  }
}

function editConfigFileProperties(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title=Edit Config File Properties,closePrevious=false",null,srcViewRefId);
}

