/* $Id: credential.js,v 1.46 2009/06/15 11:58:42 hanifa Exp $ */
/*
This function internally calls checkbox change event method which fillsup/clears profile value
for a field based on it's selection state. If checkbox is selected then static values has to be given
If checkbox is notselected profile value will be filledin
*/
function handleStateForProfileElements(form, protocol)
{
	if(protocol == "SNMP")
	{
		callCheckBoxChangeEvent(form, form.SNMP_PORT_PROFILE, form.SNMP_PORT, form.SNMP_PROFILELIST.value, 'SnmpPort');
		callCheckBoxChangeEvent(form, form.SNMP_READCOMMUNITY_PROFILE, form.SNMP_READCOMMUNITY, form.SNMP_PROFILELIST.value, 'ReadCommunity');
		callCheckBoxChangeEvent(form, form.SNMP_WRITECOMMUNITY_PROFILE, form.SNMP_WRITECOMMUNITY, form.SNMP_PROFILELIST.value, 'WriteCommunity');
		callCheckBoxChangeEvent(form, form.SNMP_USERNAME_PROFILE, form.SNMP_USERNAME, form.SNMP_PROFILELIST.value, 'UserName');
		callCheckBoxChangeEvent(form, form.SNMP_CONTEXTNAME_PROFILE, form.SNMP_CONTEXTNAME, form.SNMP_PROFILELIST.value, 'ContextName');
		callCheckBoxChangeEvent(form, form.SNMP_AUTHPROTOCOL_PROFILE, form.SNMP_AUTHPROTOCOL, form.SNMP_PROFILELIST.value, 'AuthProtocol');
		callCheckBoxChangeEvent(form, form.SNMP_AUTHPASSWORD_PROFILE, form.SNMP_AUTHPASSWORD, form.SNMP_PROFILELIST.value, 'AuthPassword');
		callCheckBoxChangeEvent(form, form.SNMP_PRIVPROTOCOL_PROFILE, form.SNMP_PRIVPROTOCOL, form.SNMP_PROFILELIST.value, 'PrivProtocol');
		callCheckBoxChangeEvent(form, form.SNMP_PRIVPASSWORD_PROFILE, form.SNMP_PRIVPASSWORD, form.SNMP_PROFILELIST.value, 'PrivPassword');		
		callCheckBoxChangeEvent(form, form.SNMP_VERSION_PROFILE, form.SNMP_VERSION, form.SNMP_PROFILELIST.value,'SnmpVersion');
	}
	else if(protocol == "TELNET")
	{
		callCheckBoxChangeEvent(form, form.TELNET_LOGINNAME_PROFILE, form.TELNET_LOGINNAME, form.TELNET_PROFILELIST.value, 'TELNET_LoginName');
		callCheckBoxChangeEvent(form, form.TELNET_PASSWORD_PROFILE, form.TELNET_PASSWORD, form.TELNET_PROFILELIST.value, 'TELNET_Password');
		callCheckBoxChangeEvent(form, form.TELNET_PROMPT_PROFILE, form.TELNET_PROMPT, form.TELNET_PROFILELIST.value, 'TELNET_Prompt');
		callCheckBoxChangeEvent(form, form.TELNET_ENABLEUSERNAME_PROFILE, form.TELNET_ENABLEUSERNAME, form.TELNET_PROFILELIST.value, 'TELNET_EnableUserName');
		callCheckBoxChangeEvent(form, form.TELNET_ENABLEPASSWORD_PROFILE, form.TELNET_ENABLEPASSWORD, form.TELNET_PROFILELIST.value, 'TELNET_EnablePassword');
		callCheckBoxChangeEvent(form, form.TELNET_ENABLEPROMPT_PROFILE, form.TELNET_ENABLEPROMPT, form.TELNET_PROFILELIST.value, 'TELNET_EnablePrompt');

	}
	else if(protocol == "SSH")
	{
		callCheckBoxChangeEvent(form, form.SSH_LOGINNAME_PROFILE, form.SSH_LOGINNAME, form.SSH_PROFILELIST.value, 'SSH_LoginName');
		callCheckBoxChangeEvent(form, form.SSH_PASSWORD_PROFILE, form.SSH_PASSWORD, form.SSH_PROFILELIST.value, 'SSH_Password');
		callCheckBoxChangeEvent(form, form.SSH_PROMPT_PROFILE, form.SSH_PROMPT, form.SSH_PROFILELIST.value, 'SSH_Prompt');
		callCheckBoxChangeEvent(form, form.SSH_ENABLEUSERNAME_PROFILE, form.SSH_ENABLEUSERNAME, form.SSH_PROFILELIST.value, 'SSH_EnableUserName');
		callCheckBoxChangeEvent(form, form.SSH_ENABLEPASSWORD_PROFILE, form.SSH_ENABLEPASSWORD, form.SSH_PROFILELIST.value, 'SSH_EnablePassword');
		callCheckBoxChangeEvent(form, form.SSH_ENABLEPROMPT_PROFILE, form.SSH_ENABLEPROMPT, form.SSH_PROFILELIST.value, 'SSH_EnablePrompt');

	}
	else
	{
		alert("Undefined protocol in handleStateForProfileElements");
	}
}


function credential_storeOldValue(textFieldObj, propName)
{
creOldVal[propName]=textFieldObj.value;
}

/*
This method fillsup/clears profile value in corresponding textfield based on selected profile
for a field based on it's selection state. If checkbox is selected then static values has to be given
If checkbox is notselected profile value will be filledin
*/
function callCheckBoxChangeEvent(form, checkBoxObj, textFieldObj, selectedProfile, propName)
{
	//alert("check box change event called");
	// if checkbox is selcted get back old credential values
	if(checkBoxObj.checked)
	{
		textFieldObj.disabled=false;
		textFieldObj.className="textfield";
		//textFieldObj.value = creOldVal[propName]; 
	}
	else
	{
	     if(selectedProfile != "")
	     {
		var newValue = proMap[selectedProfile][propName];
		textFieldObj.value=newValue;
		textFieldObj.disabled=true;
		textFieldObj.className="textdisabled";
	     }
	}
	
	if(textFieldObj.name == "SNMP_VERSION")
	{
		changeSnmpVersionInfo(MM_findObj("SNMP_VERSION"),true);
	}
}


function getCredentialCheckBoxes(form, protocol)
{
	var a = new Array();
	if(protocol == "SNMP")
	{
		a[0]=form.SNMP_PORT_PROFILE;
		a[1]=form.SNMP_READCOMMUNITY_PROFILE;
		a[2]=form.SNMP_WRITECOMMUNITY_PROFILE;
		a[3]=form.SNMP_VERSION_PROFILE;		
		a[3]=form.SNMP_USERNAME_PROFILE;
		a[4]=form.SNMP_CONTEXTNAME_PROFILE;
		a[5]=form.SNMP_AUTHPROTOCOL_PROFILE;
		a[6]=form.SNMP_AUTHPASSWORD_PROFILE;
		a[7]=form.SNMP_PRIVPROTOCOL_PROFILE;
		a[8]=form.SNMP_PRIVPASSWORD_PROFILE;
	}
	else if(protocol == "TELNET")
	{
		a[0]=form.TELNET_LOGINNAME_PROFILE;
		a[1]=form.TELNET_PASSWORD_PROFILE;
		a[2]=form.TELNET_PROMPT_PROFILE;
		a[3]=form.TELNET_ENABLEUSERNAME_PROFILE;
		a[4]=form.TELNET_ENABLEPASSWORD_PROFILE;
		a[5]=form.TELNET_ENABLEPROMPT_PROFILE;
	}
	else if(protocol == "SSH")
	{
		a[0]=form.SSH_LOGINNAME_PROFILE;
		a[1]=form.SSH_PASSWORD_PROFILE;
		a[2]=form.SSH_PROMPT_PROFILE;
		a[3]=form.SSH_ENABLEUSERNAME_PROFILE;
		a[4]=form.SSH_ENABLEPASSWORD_PROFILE;
		a[5]=form.SSH_ENABLEPROMPT_PROFILE;
	}
	else
	{
		alert("Undefined protocol in getCredentialCheckBoxes");
	}

	return a;
}

function credential_handleProfileChangeEvent(form, protocol)
{
	if(protocol == "SNMP")
	{
		var selectValue = false;
		if(form.SNMP_PROFILELIST.value == "")
		{
			selectValue = true;		
		}
		form.SNMP_PORT_PROFILE.checked=selectValue;
		form.SNMP_READCOMMUNITY_PROFILE.checked=selectValue;
		form.SNMP_WRITECOMMUNITY_PROFILE.checked=selectValue;
		
		form.SNMP_VERSION_PROFILE.checked=selectValue;
		form.SNMP_USERNAME_PROFILE.checked=selectValue;
		form.SNMP_CONTEXTNAME_PROFILE.checked=selectValue;
		form.SNMP_AUTHPROTOCOL_PROFILE.checked=selectValue;
		form.SNMP_AUTHPASSWORD_PROFILE.checked=selectValue;
		form.SNMP_PRIVPROTOCOL_PROFILE.checked=selectValue;
		form.SNMP_PRIVPASSWORD_PROFILE.checked=selectValue;		
	}
	else if(protocol == "TELNET")
	{
		var selectValue = false;
		if(form.TELNET_PROFILELIST.value == "")
		{
			selectValue = true;		
		}

		form.TELNET_LOGINNAME_PROFILE.checked=selectValue;
		form.TELNET_PASSWORD_PROFILE.checked=selectValue;
		form.TELNET_PROMPT_PROFILE.checked=selectValue;
		form.TELNET_ENABLEUSERNAME_PROFILE.checked=selectValue;
		form.TELNET_ENABLEPASSWORD_PROFILE.checked=selectValue;
		form.TELNET_ENABLEPROMPT_PROFILE.checked=selectValue;
	}
	else if(protocol == "SSH")
	{
		var selectValue = false;
		if(form.SSH_PROFILELIST.value == "")
		{
			selectValue = true;		
		}

		form.SSH_LOGINNAME_PROFILE.checked=selectValue;
		form.SSH_PASSWORD_PROFILE.checked=selectValue;
		form.SSH_PROMPT_PROFILE.checked=selectValue;
		form.SSH_ENABLEUSERNAME_PROFILE.checked=selectValue;
		form.SSH_ENABLEPASSWORD_PROFILE.checked=selectValue;
		form.SSH_ENABLEPROMPT_PROFILE.checked=selectValue;
	}
	else
	{
		alert("Undefined protocol in credential_selectAllCheckBoxes");
	}

	credential_handleCheckBoxEnableStatus(form, protocol);
	handleStateForProfileElements(form,protocol);

	if(protocol == "SNMP")
	{
		if(form.SNMP_PROFILELIST.value == "")
		{
			changeSnmpVersionInfo(MM_findObj("SNMP_VERSION"));
		}
	}	
}

function credential_handleCheckBoxEnableStatus(form, protocol)
{
	
//	alert("ProtocolName"+protocol +"aa "+(protocol == "SNMP"));

	var disableStatus = false;
	if(protocol == "SNMP" && form.SNMP_PROFILELIST.value == "")
	{
		disableStatus = true;
	}
	else if(protocol =="TELNET" && form.TELNET_PROFILELIST.value == "")
	{
		disableStatus = true;
	}
	else if(protocol =="SSH" && form.SSH_PROFILELIST.value == "")
	{
		disableStatus = true;
	}
	var arr = getCredentialCheckBoxes(form,protocol)
	//alert("Array length "+arr.length + " disableStatus="+disableStatus);
	for(var i = 0; i < arr.length; i++)
	{
		arr[i].disabled=disableStatus;
	}
}

function validateCredentialValues(form)
{
    var selprotocol = form.protocolCombinationList.options[form.protocolCombinationList.selectedIndex].value;
    if(selprotocol == 'SNMP - TFTP')
    {
    	 if(trimAll(form.SNMP_PORT.value).length > 0 && !isContainOnlyNumericValues(form.SNMP_PORT, 'SNMP Port'))
    	 {
		return false;
	 }
	 if(form.SNMP_VERSION.options[form.SNMP_VERSION.selectedIndex].value == '3' && trimAll(form.SNMP_USERNAME.value).length == 0)
	 {
	 	form.SNMP_USERNAME.clear();
	 	form.SNMP_USERNAME.focus();
	 	alert('Enter User Name value');
	 	return false;
	 }
    }
    else if(selprotocol == 'TELNET - TFTP' || selprotocol == 'TELNET') 
    {
    	if(trimAll(form.TELNET_PORT.value).length > 0 && !isContainOnlyNumericValues(form.TELNET_PORT, 'Telnet Port'))
    	{
    	    return false;
    	}
	else
	{
	    return validateTelnetCredentials(form);	
	}
    }
    else if(selprotocol == 'SSH - TFTP' || selprotocol == 'SSH' || selprotocol == 'SSH - SCP')
    {
    	if(trimAll(form.SSH_PORT.value).length > 0 && !isContainOnlyNumericValues(form.SSH_PORT, 'SSH Port'))
    	{
    	    return false;
    	}
	else
	{
	    return validateSSHCredentials(form);	
	}
    }
}

function validateTelnetCredentials(form)
{
    if(trimAll(form.TELNET_PROMPT.value).length == 0)
    {
        alert("Enter value for Prompt");
        return false;
    }
    
    if(trimAll(form.TELNET_ENABLEUSERNAME.value).length > 0 || trimAll(form.TELNET_ENABLEPASSWORD.value).length > 0)
    {
    	if(trimAll(form.TELNET_ENABLEPROMPT.value).length == 0)
    	{
    	    alert("Enter value for Enable Prompt");
    	    return false;
    	}
    }
    return true;
}


function validateSSHCredentials(form)
{
    if(trimAll(form.SSH_PROMPT.value).length == 0)
    {
        alert("Enter value for Prompt");
        return false;
    }
    
    if(trimAll(form.SSH_ENABLEUSERNAME.value).length > 0 || trimAll(form.SSH_ENABLEPASSWORD.value).length > 0)
    {
    	if(trimAll(form.SSH_ENABLEPROMPT.value).length == 0)
    	{
    	    alert("Enter value for Enable Prompt");
    	    return false;
    	}
    }
    return true;
}


function showHideCredentialComponents(selected)
{
//alert("selected is "+selected);
    var snmpTftpObj = MM_findObj('SNMP - TFTP');
    var telnetTftpObj = MM_findObj('TELNET - TFTP');
    var sshTftpObj = MM_findObj('SSH - TFTP');

    if(selected == 'SNMP - TFTP')
    {
	    //     alert("inside snmp-tftp");
	    snmpTftpObj.className='tablerowslight';
	    telnetTftpObj.className='hide';
	    sshTftpObj.className='hide';

    }
    else if(selected == 'TELNET - TFTP' || selected == 'TELNET')
    {
	    //     alert("inside telnet-tftp");
	    snmpTftpObj.className='hide';
	    telnetTftpObj.className='tablerowslight';
	    sshTftpObj.className='hide';

    }
    else if(selected == 'SSH - TFTP' || selected == 'SSH' || selected == 'SSH - SCP')
    {
	    //     alert("inside ssh-tftp");
	    snmpTftpObj.className='hide';
	    telnetTftpObj.className='hide';
	    sshTftpObj.className='tablerowslight';
    }
    else
    {
	alert("Unknown option "+selected+" in showHideCredentialComponents method");
    }

}


function changeCredentialViewToEditMode(form, editMode)
{
//alert("Inside changeCredentialViewToEditMode function. Params editMode:"+editMode + "Form Object:"+form);
	var visibleInEditMode = new Array();
	visibleInEditMode[0]='ButtonRow';
	visibleInEditMode[1]='ProtolistEdit';
	visibleInEditMode[2]='SnmpSharedCreEdit';
	visibleInEditMode[3]='TelnetSharedCreEdit';
	visibleInEditMode[4]='SSHSharedCreEdit';
    visibleInEditMode[5]='BackupDeviceRow';
 //   visibleInEditMode[6]='telnet_adv_link';
  //  visibleInEditMode[7]='snmp_adv_link';
   // visibleInEditMode[8]='ssh_adv_link';
   	var hiddenInEditMode = new Array();
	hiddenInEditMode[0]='EditRow';
	hiddenInEditMode[1]='ProtolistView';
	hiddenInEditMode[2]='SnmpSharedCreView';
	hiddenInEditMode[3]='TelnetSharedCreView';
	hiddenInEditMode[4]='SSHSharedCreView';
	//hiddenInEditMode[5]='TestCredentialsRow';

	var editElementsClass='tablerowslight';
	var viewElementsClass='hide';
	var elementDisableStatus = 'false';
if(!editMode)
{
elementDisableStatus = 'true';
editElementsClass='hide';
viewElementsClass='tablerowslight';
}
//alert("before disabling form"+form + " edit mode "+editMode);
disableAllElements(form, elementDisableStatus);
// showing TestCredentialInupt info
document.getElementById("TestCredentialInput").disabled = false;
document.getElementById("EditCredentialInput").disabled = false;

if(editMode)
{ 
// once mode is changed we will invoke script that handles profileChangeEvent 
	credential_handleCheckBoxEnableStatus(form, 'SNMP');
	handleStateForProfileElements(form, 'SNMP');

	credential_handleCheckBoxEnableStatus(form, 'TELNET');
	handleStateForProfileElements(form, 'TELNET');

	credential_handleCheckBoxEnableStatus(form, 'SSH');
	handleStateForProfileElements(form, 'SSH');
    
    // Enable/Disable 'Update and Test' option
    document.getElementById("UPDATE_AND_TEST_BUTTON").disabled = disabletestoption;
    //credential_handleProfileChangeEvent(form, 'SNMP'); 
//credential_handleProfileChangeEvent(form, 'TELNET'); 
}


//alert("before visible elements set form"+form + " edit mode "+editMode);
	for(var i = 0; i < visibleInEditMode.length; i++)
	{
		var objects = MM_findObj(visibleInEditMode[i]);
		objects.className=editElementsClass;
	}

//alert("before invisible elements set form"+form + " edit mode "+editMode);
	for(var i = 0; i < hiddenInEditMode.length; i++)
	{
		//alert(hiddenInEditMode[i]);
		var objects = MM_findObj(hiddenInEditMode[i]);
		objects.className=viewElementsClass;
	}


}

function addProfileValuesIntoVar(profileName, profileValues)
{
	proMap[profileName]=profileValues;
	form=document.CredentialView;

	snmpOptionObj = new Option(profileName, profileName, false, true);
	form.SNMP_PROFILELIST.options[form.SNMP_PROFILELIST.length] = snmpOptionObj;
	credential_handleProfileChangeEvent(form, 'SNMP'); 

	telnetOptionObj = new Option(profileName, profileName, false, true);
	form.TELNET_PROFILELIST.options[form.TELNET_PROFILELIST.length] = telnetOptionObj;
	credential_handleProfileChangeEvent(form, 'TELNET'); 

	sshOptionObj = new Option(profileName, profileName, false, true);
	form.SSH_PROFILELIST.options[form.SSH_PROFILELIST.length] = sshOptionObj;
	credential_handleProfileChangeEvent(form, 'SSH'); 

}

function hideEditRow(value)
{

    var obj = document.getElementById("EditRow");
    obj.className = (value) ? "hide" : "";
}

function setTestCredentialsParameters(resourceid)
{
    document.getElementById("UPDATE_TYPE").value = "UPDATE_AND_TEST";
    var backupobj = document.getElementById("backupstatusc");
    // Getting the backup enbaled option value
    var backupenabled = backupobj.checked;
    // Suspenpending the backup operation
    backupobj.checked = false;
    // Popup TestCredential Page
    loadTestCredentialsPage(resourceid,backupenabled);
}

function loadTestCredentialsPage(resourceid,backupenabled)
{
    var url = 'NCMTestCredentialLazyUpdateView.cc?RESOURCEID='+resourceid+'&BACKUP_ENABLED='+backupenabled;
    window.open(url,'_testcredentials','width=780,height=350,scrollbars=no');
}

function showHideTable(divId)
{
		var showHideObjects = MM_findObj(divId);
		if(showHideObjects.className == "hide")
		{
		showHideObjects.className='tablerowslight';
		}
		else
		{
		showHideObjects.className='hide';
		}
}

function imageStateChange(showDivId,hideDivId)
{
     var showObj = MM_findObj(showDivId);
     var hideObj = MM_findObj(hideDivId);
        
     showObj.className='';
     hideObj.className='hide';

document.getElementById(showDivId+'_tab').className="linktabs_selected";
document.getElementById(hideDivId+"_tab").className="linktabs_notselected";
}


/*
function imageStateChange(divId,collapsedImg,showingImg)
{
     var showHideObjects = MM_findObj(divId);
     var collImage = document.getElementById(collapsedImg);
     var showImage = document.getElementById(showingImg);	 
	 
    if(showHideObjects.className == "hide")
    {
        showHideObjects.className='tablerowslight';
        collImage.className = 'hide';
		showImage.className = '';
    }
    else
    {
        showHideObjects.className='hide';
        collImage.className = '';
		showImage.className = 'hide';        
    }

}
*/


function changeAuthProtocolInfo(authprotocolobj,calledFromProfile)
{
    var value = authprotocolobj.options[authprotocolobj.selectedIndex].value;
    if(value == "20")
    {
    	MM_findObj("SNMP_AUTHPASSWORD").disabled = true;
    	MM_findObj("SNMP_PRIVPROTOCOL").disabled = true;
    	MM_findObj("SNMP_PRIVPASSWORD").disabled = true;
    }
    else
    {
    	MM_findObj("SNMP_AUTHPASSWORD").disabled = calledFromProfile;
    	var privprotocol = MM_findObj("SNMP_PRIVPROTOCOL");
    	privprotocol.disabled = calledFromProfile;
    	
    	changePrivProtocolInfo(privprotocol,calledFromProfile);
    }
}


function changePrivProtocolInfo(privprotocolobj,calledFromProfile)
{
    var value = privprotocolobj.options[privprotocolobj.selectedIndex].value;
    if(value == "51")
    {
    	MM_findObj("SNMP_PRIVPASSWORD").disabled = true;
    }
    else
    {
    	MM_findObj("SNMP_PRIVPASSWORD").disabled = calledFromProfile;    
    }
}

function changeSnmpVersionInfo(versionobj,calledFromProfile)
{
    var snmpversion = versionobj.options[versionobj.selectedIndex].value;
    if(snmpversion == "3")
    {    
        MM_findObj("SNMP_USERNAME_TR").className = "";
        MM_findObj("SNMP_CONTEXTNAME_TR").className = "";
        MM_findObj("SNMP_AUTHPROTOCOL_TR").className = "";
        MM_findObj("SNMP_AUTHPASSWORD_TR").className = "";
        MM_findObj("SNMP_PRIVPROTOCOL_TR").className = "";
        MM_findObj("SNMP_PRIVPASSWORD_TR").className = "";

        MM_findObj("SNMP_READCOMMUNITY_TR").className = "hide";
        MM_findObj("SNMP_WRITECOMMUNITY_TR").className = "hide";

	changeAuthProtocolInfo(MM_findObj("SNMP_AUTHPROTOCOL"),calledFromProfile);
	changePrivProtocolInfo(MM_findObj("SNMP_PRIVPROTOCOL"),calledFromProfile);
    }
    else
    {
        MM_findObj("SNMP_READCOMMUNITY_TR").className = "";
        MM_findObj("SNMP_WRITECOMMUNITY_TR").className = "";
        
        MM_findObj("SNMP_USERNAME_TR").className = "hide";
        MM_findObj("SNMP_CONTEXTNAME_TR").className = "hide";
        MM_findObj("SNMP_AUTHPROTOCOL_TR").className = "hide";
        MM_findObj("SNMP_AUTHPASSWORD_TR").className = "hide";
        MM_findObj("SNMP_PRIVPROTOCOL_TR").className = "hide";
        MM_findObj("SNMP_PRIVPASSWORD_TR").className = "hide";
    }
}


// Used in Credential Profile
function changeProfileAuthProtocolInfo(authprotocolobj)
{
    var value = authprotocolobj.options[authprotocolobj.selectedIndex].value;
    if(value == "20")
    {
    	MM_findObj("snmp_authpassword").disabled = true;
    	MM_findObj("snmp_privprotocol").disabled = true;
    	MM_findObj("snmp_privpassword").disabled = true;
    }
    else
    {
    	MM_findObj("snmp_authpassword").disabled = false;
    	var privprotocol = MM_findObj("snmp_privprotocol");
    	privprotocol.disabled = false;
    	
    	changeProfilePrivProtocolInfo(privprotocol);
    }
}

function changeProfilePrivProtocolInfo(privprotocolobj)
{
    var value = privprotocolobj.options[privprotocolobj.selectedIndex].value;
    if(value == "51")
    {
    	MM_findObj("snmp_privpassword").disabled = true;
    }
    else
    {
    	MM_findObj("snmp_privpassword").disabled = false;    
    }
}

function changeProfileSnmpVersionInfo(versionobj)
{
    var snmpversion = versionobj.options[versionobj.selectedIndex].value;
    if(snmpversion == "3")
    {    
        MM_findObj("SNMP_PR_USERNAME_TR").className = "";
        MM_findObj("SNMP_PR_CONTEXTNAME_TR").className = "";
        MM_findObj("SNMP_PR_AUTHPROTOCOL_TR").className = "";
        MM_findObj("SNMP_PR_AUTHPASSWORD_TR").className = "";
        MM_findObj("SNMP_PR_PRIVPROTOCOL_TR").className = "";
        MM_findObj("SNMP_PR_PRIVPASSWORD_TR").className = "";

        MM_findObj("SNMP_PR_READCOMMUNITY_TR").className = "hide";
        MM_findObj("SNMP_PR_WRITECOMMUNITY_TR").className = "hide";
    }
    else
    {    
        MM_findObj("SNMP_PR_READCOMMUNITY_TR").className = "";
        MM_findObj("SNMP_PR_WRITECOMMUNITY_TR").className = "";
        
        MM_findObj("SNMP_PR_USERNAME_TR").className = "hide";
        MM_findObj("SNMP_PR_CONTEXTNAME_TR").className = "hide";
        MM_findObj("SNMP_PR_AUTHPROTOCOL_TR").className = "hide";
        MM_findObj("SNMP_PR_AUTHPASSWORD_TR").className = "hide";
        MM_findObj("SNMP_PR_PRIVPROTOCOL_TR").className = "hide";
        MM_findObj("SNMP_PR_PRIVPASSWORD_TR").className = "hide";
    }
}
