/* $Id: validate.js,v 1.24 2009/06/09 14:03:31 hanifa Exp $ */
function checkIfTextfieldEmpty(textfieldComp,errorMessage)
{
  //alert("In checkIfTextfieldEmpty .......");
  var name = trimAll(textfieldComp.value);
  if(name.length == 0)
  {
    alert(errorMessage);
    return true;
  }
  
  return false;
  
}

function checkIfSelectEmpty(selectComp,errorMessage)
{
  //alert('In checkIfSelectEmpty .......');
  var len = selectComp.options.length;
  if(len == 0)
  {
    alert(errorMessage);
    return true;
  }
  
  return false;
}

function underConstruction()
{
    alert("Under Construction");
}

function isValidIPAddress(ipaddr)
{
   var re = /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/;
   if (re.test(ipaddr)) 
   {
      var parts = ipaddr.split(".");
      if (parseInt(parseFloat(parts[0])) == 0) 
      { 
        return false; 
      }
      for (var i=0; i<parts.length; i++) 
      {
         if (parseInt(parseFloat(parts[i])) > 255) 
         { 
           return false;
         }
      }
      return true;
   } 
   else 
   {
      return false;
   }
}




 
    function checkEmailAddress(str)
    {
            var at="@"
            var dot="."
            var lat=str.indexOf(at)
            var lstr=str.length
            var ldot=str.indexOf(dot)
            var errorMessage = "The address " + str + " is not valid. Please enter a valid E-Mail ID"
            if (str.indexOf(at)==-1)
            {
                alert(errorMessage)
                return false
            }
            
            if (str.indexOf(at)==-1 || str.indexOf(at)==0 || str.indexOf(at)==lstr)
            {
                alert(errorMessage)
                return false
            }
            
            if (str.indexOf(dot)==-1 || str.indexOf(dot)==0 || str.indexOf(dot)==lstr)
            {
                alert(errorMessage)
                return false
            }
            
            if (str.indexOf(at,(lat+1))!=-1)
            {
                alert(errorMessage)
                return false
            }
            
            if (str.substring(lat-1,lat)==dot || str.substring(lat+1,lat+2)==dot)
            {
                alert(errorMessage)
                return false
            }
            
            if (str.indexOf(dot,(lat+2))==-1)
            {
                alert(errorMessage)
                return false
            }
            
            if (str.indexOf(" ")!=-1)
            {
                alert(errorMessage)
                return false
            }
            
            return true
        }

function hostNameValidation(hostName)
{
    if(hostName.length == 0)
    {
        alert("Enter the hostname/IP address");
        return false;
    }

    var parts = hostName.split(".");

    if(parts[0].length == 0)
    {
        alert("Enter a valid hostname/IP address")
        return false;
    }

    if(isNumber(parts[0]))
    {
        if(!isValidIPAddress(hostName))
        {
            alert("Enter a valid IP address");
            return false;
        }
    }
    
    return true;

}

function isValidSyslogFrwd(ipAddress)
{
	if(isNotEmpty(ipAddress))
	{
		var ips = ipAddress.split(",");
		for (var i=0; i < ips.length; i++) 
		{
			if(!isValidIPAddress(ips[i].trim()))
			{
				alert("Invalid Forwarder IP address : >>> " + ips[i]);
				return false;
			}
		}
	}
	return true;
}


function isNumber(str)
{
    str = trimAll(str);
    if(str.length==0) return false;
    numdecs = 0;
    for (i = 0; i < str.length; i++)
    {
        mychar = str.charAt(i);
        if ((mychar >= "0" && mychar <= "9") || mychar == "." )
        {
            if (mychar == ".")
                numdecs++;
        }
        else return false;
    }
    if (numdecs > 1){return false;}
    return true;
}

function loadDiscoverStatusPage(addressid)
{
       var url = 'NCMAdminAutoDiscoveryMessageStatus.cc?ADDRESSID=' + addressid;
       window.open(url,'autodiscovery','width=400,height=200')
         
}

function isAlphaNumericDotDash(str, formElement){
   if(!isNotEmpty(str))
   {
     return false;
   }

    var objRegExp = /^[a-zA-Z0-9_\-\. ]+$/;
    if(objRegExp.test(str)){
        return true;
    }
    return false;
}

function isContainOnlyNumericValues(textObj,fieldName)
{
    if (parseInt(textObj.value) != textObj.value)
    {
        alert("Enter a numeric value for the field \""+fieldName+"\"");
        textObj.focus();
        textObj.select();
        return false;
    }
    return true;
}


/* For validation SNMPTrapSettings screen */

function validateTrapPort(value,formElement)
{
  value = trimAll(value);
  if(isNotEmpty(value))
  {
    if(!isContainOnlyNumericValues(formElement,"Destination Port"))
    {
        return false;
    }
  }

  return true;
}


/* validate the edit conf properties form*/

function validate_edit_form(form)
{
    if(!isNotEmpty(form.ANNOTATION.value))
    {
      alert("Enter proper value for the annotation");
      form.ANNOTATION.focus();
      return false;
    }
    else if(!isNotEmpty(form.CHANGEDBY.value))
    {
      alert("Enter proper value for the changed by");
      form.CHANGEDBY.focus();
      return false;
    }
   
    else
    {
        return true;
    }
}

function validate_auth_reason(form)
{
      if(!isNotEmpty(form.MESSAGE_BOX.value))
        {
            alert("Enter proper value for the changes");
            form.MESSAGE_BOX.focus();
            return false;
        }
      else
      {
            return true;
      }

}
